
/* special structure, used only by art_name_array[] */

typedef struct namebytype {
  char *name; /* generic name to call artifacts of this type */
  int type;   /* matching type */
} arttypename;


/* these are needed for creation of a linked list of
 * pointers to all (hostile) monster objects */

static int nrofmon=0;
static objectlink *first_mon_info;


/* this is needed to keep track of status of initialization
 * of the message file */ 
static int nrofmsg=0;
static linked_char *first_msg;


static uint32 spellpathdef[NRSPELLPATHS] = {
  PATH_PROT,
  PATH_FIRE,
  PATH_FROST,
  PATH_ELEC,
  PATH_MISSILE,
  PATH_SELF,
  PATH_SUMMON,
  PATH_ABJURE,
  PATH_RESTORE,
  PATH_DETONATE,
  PATH_MIND,
  PATH_CREATE,
  PATH_TELE,
  PATH_INFO,
  PATH_TRANSMUTE,
  PATH_TRANSFER,
  PATH_TURNING,
  PATH_WOUNDING,
  PATH_DEATH,
  PATH_LIGHT
};

/* if it isnt listed here, then art_attr_msg will never generate
 * a message for this type of artifact. -b.t. */

static arttypename art_name_array[] = {
  {"Helmet", HELMET},
  {"Amulet", AMULET},
  {"Shield", SHIELD},
  {"Bracers", BRACERS},
  {"Boots", BOOTS},
  {"Cloak", CLOAK},
  {"Gloves", GLOVES},
  {"Gridle", GIRDLE},
  {"Ring", RING},
  {"Horn", HORN},
  {"Missile Weapon", BOW},
  {"Missile", ARROW},
  {"Hand Weapon", WEAPON},
  {"Artifact", SKILL},
  {"Food", FOOD},
  {"Body Armour", ARMOUR}
};

static char *light_book_name[] = {
  "calendar",
  "datebook",
  "diary",
  "guide",
  "guidebook",
  "handbook",
  "ledger",
  "manual",
  "notes",
  "notebook",
  "octavo",
  "pamphlet",
  "practicum",
  "script",
  "transcript"
};
 
static char *heavy_book_name[] = {
  "catalog",
  "compendium",
  "encyclopedia",
  "guide",
  "grimore",
  "grimorie",
  "handbook",
  "manual",
  "opus",
  "tome",
  "treatise",
  "volume",
  "work"
};

static char *book_author[] = {
  "Abdulah",
  "Alhezred",
  "Arundel",
  "Arvind",
  "Aerlingas",
  "Bacon",
  "Baliqendii",
  "Bosworth",
  "Beathis",
  "Bertil",
  "Cauchy",
  "Chakrabarti",
  "Dirk",
  "Djwimii",
  "Fendris",
  "Frank",
  "Harlod",
  "Havlor", /* ancient warrior scribe :) */
  "Ichibod",
  "Janus",
  "June",
  "Magnus",
  "Magnuson",
  "Nandii",
  "Nitfederwall",
  "Norris",
  "Parael",
  "Penhew",
  "Sophia",
  "Skilly",
  "Tahir",
  "Thockmorton",
  "van der Waalis",
  "van Helsing",
  "van Pelt",
  "Voormis",
  "Xavier",
  "Xeno",
  "Zardoz",
  "Zagy"
};

static char *book_descrpt[] = {
  "ancient",
  "cryptic",
  "cryptical",
  "dusty",
  "hiearchical",
  "grizzled",
  "gold-guilt",
  "great",
  "lost",
  "magnificent",
  "musty",
  "mythical",
  "mystical",
  "rustic",
  "stained",
  "silvered",
  "transcendental",
  "weathered"
};

static char *mage_book_name[] = { 
  "magical compendium",
  "grimore",
  "grimorie",
  "mystical manual",
  "spellbook",
  "spellbook",
  "spellbook",
  "spellbook",
  "magical tome",
  "wizard's treatise"
};

static char *priest_book_name[] = {   
  "eccumenical treatise", 
  "hymnal",
  "prayerbook",
  "prayerbook",
  "sacred text"
};

